package com.winhc.bigdata.flink.java.utils;

import com.alibaba.hologres.client.HoloClient;
import com.alibaba.hologres.client.HoloConfig;
import com.alibaba.hologres.client.exception.HoloClientException;
import com.alibaba.hologres.client.model.WriteMode;
import org.apache.commons.lang3.StringUtils;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Collection;
import java.util.Set;
import java.util.concurrent.ExecutionException;

/**
 * @author π
 * @Description:
 * @date 2021/10/11 11:39
 */
public class HoloUtils {
    private static String url;

    static {
        if (BaseUtils.isWindows()) {
            url = "jdbc:postgresql://hgprecn-cn-zvp2dvgsr005-cn-shanghai.hologres.aliyuncs.com:80/winhc_test_db";
        } else {
            url = "jdbc:postgresql://hgprecn-cn-zvp2dvgsr005-cn-shanghai-vpc.hologres.aliyuncs.com:80/winhc_test_db";
        }
    }

    private static final String username = "LTAI4G4n7pAW8tUbJVkkZQPD";
    private static final String password = "uNJOBskzcDqHq1TYG3m2rebR4c1009";
    private static HoloClient client = null;

    public static HoloClient init() throws HoloClientException {
        HoloConfig config = new HoloConfig();
        config.setJdbcUrl(url);
        config.setUsername(username);
        config.setPassword(password);
        config.setWriteMode(WriteMode.INSERT_OR_REPLACE);//配置主键冲突时策略
        client = new HoloClient(config);
        return client;
    }

    public static String genInsertSql(String tableName, Set<String> keys, Collection<Object> values, Collection<Object> primaryKeys) {
        return "INSERT INTO " + tableName + " \n" +
                "(" + StringUtils.join(keys, ",") + ") VALUES ('" + StringUtils.join(values, "','") + "') \n" +
                "ON conflict(" + StringUtils.join(primaryKeys, ",") + ") DO UPDATE \n" +
                "SET (" + StringUtils.join(keys, ",") + ") = ROW(excluded.*)\n";

    }
}
